// --------------------------------------------------------------------------
// Scadenzario
// fv 24/8/94
// --------------------------------------------------------------------------

#include <sheet.h>
#include "pagament.h"

#include "cg2102.h"
#include "cg2100.h"
#include "cg21sld.h"

#include <clifo.h>
#include <partite.h>
#include <scadenze.h>

bool TPrimanota_application::pag_notify(TSheet_field&, int r, KEY k)
{                                                          
  TPagamento&    pag = app().pagamento();
  TSheet_field&  ps  = app().pags(); 
  TMask*         msk = &(app().curr_mask());      
  TString_array& rws = app().pag_rows();                                
  
  int rdiff = atoi(msk->get(FS_RDIFFER));
  
  // ts contiene la vecchia riga, ns la nuova                                       
  TToken_string ts(36), ns(36);

  bool doit = TRUE, m_imp = FALSE, m_perc = FALSE, m_pag = FALSE;
  bool m_scad = FALSE, m_tipo = FALSE, mod = FALSE;
  word ahiahi = P_OK;                                
  
  TString news(15), newi(15), newp(15), newt(2);                                  

  bool recalc = msk->get_bool(FS_RECALC); 
  bool mcomm  = msk->get_bool(FS_MCOMM);
  
  switch (k)
  {
  case K_SPACE:
    break;
  case K_ENTER:
    ns  = ps.row(r);     
    ts  = rws.row(r);    
    
    news = ns.get(0);
    newp = ns.get(1);
    newi = ns.get(2);
    newt = ns.get(3);                                            
    
    // qui viene il bello, si fa per dire 
    if (news != ts.get(0))  // modificata data scadenza
    {                            
      mod  = m_scad = TRUE;        
    }
    if (newp != ts.get(1))  // modificata percentuale
    {                
      mod  = m_perc = TRUE;        
    }
    if (newi != ts.get(2))  // modificato importo
    {          
       // se si modifica la percentuale l'importo non viene cagato
      if ((recalc && !m_perc) || (!recalc)) 
      {
        mod  = m_imp = TRUE;   
      }
    }
    if (newt != ts.get(3))  // modificato tipo pagamento
    {                 
      mod = m_tipo  = TRUE;      
    }
    break;
  case K_DEL:
  case K_INS:
    doit = FALSE;
    break;
  default:
    break;
  }          
  

  // settato da recalc_rate se occorre ridefinire lo sheet
  // aggiungendo o togliendo righe
  bool need_recalc = FALSE;      

  if (k == K_ENTER) 
  {
    if (mod && recalc)
    {
      // ricalcola sheet come sai fare tu
      ahiahi = pag.recalc_rate(r, m_perc, 
                               ((m_perc || m_imp) ? 
                                (m_perc ? (const char*)newp : (const char*)newi) : 
                                NULL), 
                               (m_scad ? (const char*)news : NULL),
                               (m_tipo ? (const char*)newt : NULL), 
                               rdiff, mcomm, need_recalc);
      // see if rdiff changed                          
      msk->set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
    }
    if (!recalc)
    {                              
      ahiahi = P_OK;
      // put data as they are
      TToken_string& trw = pag.rata(r);
      TToken_string  srw = trw;
      if (m_scad)  trw.add(news,3);
      if (m_perc)  trw.add(newp,1);
      if (m_imp)   trw.add(newi,4);
      if (m_tipo)  trw.add(newt,2);
      // validate the payment
      if ((ahiahi = pag.validate()) != P_OK)
        pag.rata(r) = srw;
    }
    if (ahiahi)  // any error? Rimetti le righe com'erano prima
    {  
      beep(); 
      
      // se gli errori sono voluti, spiegali
      if (!recalc)
      {                    
        TString256 s;
        pag.strerr(ahiahi,s);
        warning_box(s);
      }
      
      ps.row(r) = rws.row(r); 
      ps.force_update(r); 
    } 
    
    else if (recalc && mod && need_recalc) 
    {                                   
      // ridefinisci lo sheet sulla base delle nuove rate
      pag.set_sheet(ps);
      ps.force_update();         
      rws = ps.rows_array();      
    } 
  }
  
  return doit;
}                            

bool TPrimanota_application::codpag_handler(TMask_field& f, KEY key)
{                                 
  TMask& m = f.mask();
  
  if (key == K_TAB && (f.focusdirty() || !m.is_running()) && app().is_saldaconto())
  {
    const TString16 dt(m.get(F_DATAREG));
    app().set_pagamento(f.get(), dt);     
    app().set_scadenze(m);
  }
  return TRUE;
}
                           
void TPrimanota_application::set_pagamento(const char* c, const char* d)
{ 
  if (_pag != NULL) delete _pag;
  _pag = new TPagamento(c,d);
} 

void TPrimanota_application::set_scadenze(TMask& m)
{                                                                  
  const real imponibile(m.get(F_IMPONIBILI));   
  const real imposta(m.get(F_IMPOSTE));   
  const real spese(0.0);        
          
  TPagamento& pag = pagamento();        
  if (pag.is_new()) 
  {        
    m.disable_page(2);
    return;
  }
  else m.enable_page(2);

  m.set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
  m.set(FS_NAMEPAG, pag.name());
  m.set(FS_TIPOPR,  pag.desc_tpr());
  m.set(FS_MCOMM,   pag.mese_commerciale() ? "X" : "");
  m.set(FS_RECALC,  "X", TRUE);

  pag.set_total(imponibile, imposta, spese);                              
  pag.set_rate_auto();          
  bool new_part = TRUE; 
  
  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);

  // prepara lo sheet
  pag.set_sheet(ps);
  _pag_rows = ps.rows_array();

  // se la prima rata e' fissa non si tocca
  if (pag.tipo_prima_rata() > 0)
  {
    ps.disable_cell(0,0);
    ps.disable_cell(0,1);
    ps.disable_cell(0,2);
    ps.disable_cell(0,3);
  }              
}

bool TPrimanota_application::read_scadenze(TMask& m)
{                                                                  
  // should never happen but it doesn't hurt
  if (_rel->cg(0).empty()) return FALSE; 

  const real imponibile(m.get(F_IMPONIBILI));   
  const real imposta(m.get(F_IMPOSTE));   
  const real spese(0.0);        

  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);

  m.set(FS_RECALC, "X");
  
  TPagamento& pag = pagamento();
  pag.set_total(imponibile, imposta, spese);                              

  TLocalisamfile partita (LF_PARTITE);
  TLocalisamfile scadenza(LF_SCADENZE);

  const TRectype& testa = _rel->lfile().curr();
  const long nreg = testa.get_long("NUMREG");
  const TString16 ndoc(testa.get("NUMDOC"));
  const int tmov = testa.get_int("TIPOMOV");
  const TDate ddoc(testa.get_date("DATADOC"));
  const TDate dreg(testa.get_date("DATAREG"));                                    
  const TString16 reg (testa.get("REG")); 
  const long protiva = testa.get_long("PROTIVA"); 
  const TString16 codcaus(testa.get("CODCAUS")); 
  const TString16 codval (testa.get("CODVAL")); 
  const real cambio(testa.get("CAMBIO")); 
  
  const TString16 numpart(m.get(F_NUMRIF));
  const int anno = m.get_int(F_ANNORIF);
  
  const TRectype& prima = _rel->cg(0);
  const char sezione    = prima.get_char("SEZIONE"); // Dare/Avere
  const char tipocf     = prima.get_char("TIPOC"); // Cliente || Fornitore || Uncazzo
  const int  gruppo     = (tipocf == 'C' || tipocf == 'F') ? 0 : prima.get_int("GRUPPO");
  const int  conto      = (tipocf == 'C' || tipocf == 'F') ? 0 : prima.get_int("CONTO");
  const long sottoconto = prima.get_long("SOTTOCONTO");
  const int  nriga      = 1;
  const int  numrig     = 1;
  
  partita.put(PART_ANNO,    anno);
  partita.put(PART_NUMPART, numpart);
  partita.put(PART_NRIGA,   nriga);
  
  bool fromscratch = FALSE;
  
  if (partita.read() == NOERR)
  {    
    // se si e' specificato un codice pagamento diverso si rifa' da capo       
    if (pag.code() != partita.get("CODPAG"))
      fromscratch = TRUE;                                       
    // se invece la maschera contiene importi diversi da quelli
    // registrati si passa la palla al culano
    else if (imponibile != partita.get_real(PART_IMPORTO) || 
             imposta    != partita.get_real(PART_IMPOSTA) ||
             spese      != partita.get_real(PART_SPESE))  
    {
      fromscratch = !yesno_box("Gli importi totali delle scadenze sono stati modificati rispetto"
                               " all'ultima registrazione. Si desidera mantenere"
                               " comunque la rateazione precedente");
      // nel caso, of course, si disabilitano gli automatismi
      if(!fromscratch) m.field(FS_RECALC).set("");
    }
    if (fromscratch)
      pag.set_rate_auto();
    else
    {    
      pag.zap_rate();

      for (int i = 0; ; i++)
      { 
        // cerca rata            
        scadenza.zero();
        scadenza.put(SCAD_ANNO,    anno);
        scadenza.put(SCAD_NUMPART, numpart);
        scadenza.put(SCAD_NRATA,   i+1);
        
        if (scadenza.read() == NOERR)
        {
          const real  importo = scadenza.get(SCAD_IMPORTO); 
          const TDate scad    = scadenza.get(SCAD_DATASCAD);
          const int tipop     = scadenza.get_int(SCAD_TIPOPAG);     
          const bool paid     = scadenza.get_bool(SCAD_PAGATA);
          const TString16 ulc = scadenza.get(SCAD_ULTCLASS);
          pag.set_rata(i, importo, scad, tipop, ulc, paid);
        } 
        else break; 
      } // for
    } //else
  }
  else
    return FALSE;

  pag.set_sheet(ps);
  _pag_rows = ps.rows_array();

  // se la prima rata e' fissa non si tocca
  if (pag.tipo_prima_rata() > 0)
    ps.disable_cell(0,-1);
  
  return TRUE;
}

void TPrimanota_application::write_scadenze(const TMask& m)
{                                                                  
  real imponibile(0.0);   
  real imposta(0.0);   
  real spese(0.0);        

  // should never happen but it doesn't hurt
  CHECK(!_rel->cg(0).empty(), "Missing first line"); 

  TLocalisamfile partita (LF_PARTITE);
  TLocalisamfile scadenza(LF_SCADENZE);
  
  TRectype& r = _rel->lfile().curr();
  
  const long nreg = r.get_long("NUMREG");
  const TString16 ndoc(r.get("NUMDOC"));
  const int tmov = r.get_int("TIPOMOV");
  const TDate   ddoc(r.get_date("DATADOC"));
  const TDate   dreg(r.get_date("DATAREG"));                                    
  const TString16 reg (r.get("REG"));       
  const TString80 desc(r.get("DESCR"));
  const long protiva = r.get_long("PROTIVA"); 
  const TString16 codcaus(r.get("CODCAUS")); 
  const TString16 codval (r.get("CODVAL")); 
  const real cambio (r.get("CAMBIO")); 
  
  const TString16 numpart = m.get(F_NUMRIF);
  const int anno  = m.get_int(F_ANNORIF);
  CHECK(anno > 1900, "Anno partita non valido");
  
  char sezione    = _rel->cg(0).get_char("SEZIONE"); // Dare/Avere
  char tipocf     = _rel->cg(0).get_char("TIPOC"); // Cliente || Fornitore || Uncazzo
  int  gruppo     = (tipocf == 'C' || tipocf == 'F') ? 0 :  _rel->cg(0).get_char("GRUPPO");
  int  conto      = (tipocf == 'C' || tipocf == 'F') ? 0 :  _rel->cg(0).get_char("CONTO");
  long sottoconto = _rel->cg(0).get_long("SOTTOCONTO");
  const int  nriga      = 1;
  int  numrig     = 1;
  
  partita.put(PART_ANNO,    anno);
  partita.put(PART_NUMPART, numpart);
  partita.put(PART_NRIGA,   nriga);
  
  bool fromscratch = FALSE, new_part = TRUE;
  
  TPagamento& pag = pagamento();
  
  if (partita.read() == NOERR)
  {    
    // se si e' specificato un codice pagamento diverso si rifa' da capo       
    if (pag.code() != partita.get(PART_CODPAG))
      fromscratch = TRUE; 
    new_part = FALSE;                                      
  } 
  
  // riaggiusta partite e scadenze
  if (new_part) 
  {
    partita.zero(); 
    partita.put(PART_TIPOCF,     tipocf);
    partita.put(PART_GRUPPO,     gruppo);
    partita.put(PART_CONTO,      conto);
    partita.put(PART_SOTTOCONTO, sottoconto);
    partita.put(PART_ANNO,       anno);
    partita.put(PART_NUMPART,    numpart);
    partita.put(PART_NRIGA,      nriga);
  }   

  // put data on partita
  partita.put("TIPOMOV",tmov);
  partita.put("NREG",   nreg);
  partita.put("DATAREG",dreg); 
  partita.put("DATADOC",ddoc);
  partita.put("NUMDOC", ndoc);
  partita.put("REG",    reg);
  partita.put("DESCR",  desc);
  partita.put("PROTIVA",protiva);
  partita.put("CODCAUS",codcaus);
  partita.put("SEZ",    sezione);
  partita.put("CODPAG", pag.code());
  partita.put("CODVAL", codval);
  partita.put("CAMBIO", cambio);
  partita.put("IMPORTO",pag.imponibile());
  partita.put("IMPOSTA",pag.imposta());
  partita.put("SPESE",  pag.spese());
  partita.put("NUMRIG", numrig);
      
  if (new_part) partita.write(); 
  else          partita.rewrite();
      
  bool new_scad = FALSE;
      
  for (int i = 0; i < pag.n_rate(); i++)
  {  
    new_scad = FALSE;
    scadenza.zero();         
    scadenza.put(SCAD_TIPOCF,     tipocf);
    scadenza.put(SCAD_GRUPPO,     gruppo);
    scadenza.put(SCAD_CONTO,      conto);
    scadenza.put(SCAD_SOTTOCONTO, sottoconto);
    scadenza.put(SCAD_ANNO,       anno);
    scadenza.put(SCAD_NUMPART,    numpart);
    scadenza.put(SCAD_NRIGA,      nriga);
    scadenza.put(SCAD_NRATA,      i+1);
  
    if (scadenza.read() != NOERR)
    {   
      new_scad = TRUE;
      scadenza.zero();
      scadenza.put(SCAD_TIPOCF,     tipocf);
      scadenza.put(SCAD_GRUPPO,     gruppo);
      scadenza.put(SCAD_CONTO,      conto);
      scadenza.put(SCAD_SOTTOCONTO, sottoconto);
      scadenza.put(SCAD_ANNO,       anno);
      scadenza.put(SCAD_NUMPART,    numpart);
      scadenza.put(SCAD_NRIGA,      nriga);
      scadenza.put(SCAD_NRATA,      i+1);
    }
    // set everything 
    scadenza.put("CODPAG",    pag.code());
    scadenza.put("TIPOPAG",   pag.tipo_rata(i));
    scadenza.put("ULTCLASS",  pag.ulc_rata(i));
    scadenza.put("IMPORTO",   pag.tpay_rata(i));
    scadenza.put("DATASCAD",  pag.data_rata(i));
    scadenza.put("PAGATA",    pag.ratapagata(i));
        
    if (new_scad) scadenza.write();
    else          scadenza.rewrite();
  }

  // elimina eventuali altre scadenze oltre l'ultima registrata
  for (; !new_scad ; i++)
  {  
    scadenza.zero();
    scadenza.put(SCAD_ANNO,    anno);
    scadenza.put(SCAD_NUMPART, numpart);
    scadenza.put(SCAD_NRATA,   i+1);
      
    if (scadenza.read() == NOERR)
      scadenza.remove();
    else new_scad = TRUE;
  }
}


