USE 33
JOIN 34 ALIAS 101 INTO CODNUM=CODNUM ANNO=ANNO PROVV=PROVV NDOC=NDOC
JOIN 17 ALIAS 201 INTO TIPOCF=TIPOCF CODCF=CODCF
JOIN 20 ALIAS 202 INTO TIPOCF=TIPOCF CODCF=CODCF
JOIN %CPG ALIAS 301 INTO CODTAB=CODPAG
JOIN %VAL ALIAS 302 INTO CODTAB=CODVAL
JOIN %LNG ALIAS 303 INTO CODTAB=CODLIN
JOIN AGE ALIAS 304 INTO CODTAB=CODAG
JOIN MSP ALIAS 305 INTO CODTAB=CODSPMEZZO
JOIN POR ALIAS 306 INTO CODTAB=CODPORTO
JOIN 47 TO 101@ ALIAS 401 INTO CODART=CODART
JOIN 49 ALIAS 501 INTO CODLIS=CODLIST
JOIN 52 ALIAS 601 INTO TIPOCF=TIPOCF CODCF=CODCF NCONTR=CODCONT
JOIN 16 ALIAS 701 INTO TIPOCF=TIPOCF CODCF=CODCF CODIND=CODINDSP
JOIN 16 TO 201@ ALIAS 801 INTO TIPOCF=TIPOCF CODCF=CODCF CODIND=CODINDSP
JOIN %BAN ALIAS 901 INTO CODTAB=CODABIA+CODCABA
JOIN %BAN ALIAS 902 INTO CODTAB=CODABIP+CODCABP
JOIN NDO ALIAS 1001 INTO CODTAB=CODNOTESP1
JOIN NDO ALIAS 1002 INTO CODTAB=CODNOTESP2
JOIN 13 TO 304@ ALIAS 1101 INTO COM=COMCF
JOIN 13 TO 304@ ALIAS 1102 INTO COM=COM

END
DESCRIPTION
BEGIN
  33->* "Documenti di vendita"
  101@->* "Righe documenti di vendita"
  201@->* "Clienti/Fornitori per vendite"
  202@->* "Clienti/Fornitori"
  301@->* "CPG"
  302@->* "VAL"
  303@->* "LNG"
  304@->* "AGE"
  305@->* "MSP"
  306@->* "POR"
  401@->* "Anagrafica di magazzino"
  501@->* "Righe listini"
  601@->* "Contratti clienti"
  701@->* "Indirizzi di spedizione"
  801@->* "Indirizzi di spedizione"
  901@->* "Tabella banche"
  902@->* "Tabella banche"
  1001@->* "Tabella Note Documento"
  1002@->* "Tabella Note Documento"
  1101@->* "Comuni"
  1102@->* "Comuni"
END

SECTION HEADER ODD 33 0 0

STRINGA 1 36 1
BEGIN
 KEY "nome ditta"
 PROMPT 5 6 ""
END

STRINGA 2 36 1
BEGIN
 KEY "indirizzo ditta"
 PROMPT 5 7 ""
END

STRINGA 3 5 1
BEGIN
 KEY "cap ditta"
 PROMPT 5 8 ""
END

STRINGA 4 30 1
BEGIN
 KEY "comune ditta"
 PROMPT 12 8 ""
END

STRINGA 5 5 1
BEGIN
 KEY "scritta P.IVA"
 PROMPT 5 9 "P.IVA"
END

STRINGA 6 16 1
BEGIN
 KEY "partita iva ditta"
 PROMPT 11 9 ""
END

STRINGA 7 9 1
BEGIN
 KEY "scritta COD.FISC."
 PROMPT 5 10 "COD.FISC."
END

STRINGA 8 16 1
BEGIN
 KEY "codice fiscale ditta"
 PROMPT 15 10 ""
END

STRINGA 14 35 2
BEGIN
 KEY "destinatario, ditta"
 PROMPT 44 16 ""
 FIELD 202@->RAGSOC
END

STRINGA 15 35 2
BEGIN
 KEY "destinatario, indirizzo"
 PROMPT 44 18 ""
 FIELD 202@->INDCF
END

STRINGA 16 5 1
BEGIN
 KEY "destinatario, cap"
 PROMPT 44 20 ""
 FIELD 1101@->CAPCOM
END

STRINGA 17 30 2
BEGIN
 KEY "destinatario, comune"
 PROMPT 50 20 ""
 FIELD 1101@->DENCOM
END

STRINGA 18 2 1
BEGIN
 KEY "destinatario, procincia"
 PROMPT 82 21 ""
 FIELD 1101@->PROVCOM
END

DATA 19 8 1
BEGIN
 KEY "data bolla"
 PROMPT 60 25 ""
 FIELD 33->DATADOC
 FORMAT "1444-"
END

NUMERO 20
BEGIN
 KEY "numero bolla"
 PROMPT 71 25 ""
 FIELD 33->NDOC
END

STRINGA 21 30 2
BEGIN
 KEY "destinazione, indirizzo"
 PROMPT 5 16 ""
 FIELD 701@->INDIR
END

STRINGA 32 5 1
BEGIN
 KEY "destinazione, cap"
 PROMPT 5 19 ""
 FIELD 1102@->CAPCOM
END

STRINGA 33 21 1
BEGIN
 KEY "destinazione, comune"
 PROMPT 11 19 ""
 FIELD 1102@->DENCOM
END

STRINGA 34 2
BEGIN
 KEY "destinazione, provincia"
 PROMPT 33 19 ""
 FIELD 1102@->PROVCOM
END

NUMERO 22
BEGIN
 KEY "ordine"
 PROMPT 3 25 ""
 FIELD 33->NUMDOCRIF
END

DATA 23 8 1
BEGIN
 KEY "data conferma"
 PROMPT 16 25 ""
 FIELD 33->DATADOCRIF
 FORMAT "1444-"
END

STRINGA 24 48 1
BEGIN
 KEY "condizioni pagamento"
 PROMPT 3 27 ""
 FIELD 301@->S0
END

STRINGA 25 29 1
BEGIN
 KEY "banca appoggio"
 PROMPT 53 27 ""
 FIELD 901@->S0
END

STRINGA 26 7 1
BEGIN
 KEY "codice cliente"
 PROMPT 3 29 ""
 FIELD 33->CODCF
END

STRINGA 27 11 1
BEGIN
 KEY "partita iva cliente"
 PROMPT 12 29 ""
 FIELD 202@->PAIV
END

STRINGA 28 18 1
BEGIN
 KEY "porto"
 PROMPT 41 25 ""
 FIELD 306@->S0
END

NUMERO 29
BEGIN
 KEY "codice agente"
 PROMPT 29 29 ""
 FIELD 33->CODAG
END

STRINGA 30 28 1
BEGIN
 KEY "nome agente"
 PROMPT 33 29 ""
 FIELD 304@->S0
END

STRINGA 31 19 1
BEGIN
 KEY "causale"
 PROMPT 63 29 ""
END

END

SECTION BODY ODD 24 0 0

STRINGA 32 13 1
BEGIN
 KEY "codice articolo"
 PROMPT 5 34 ""
 FIELD 101@->CODART
END

STRINGA 33 30 1
BEGIN
 KEY "descrizione articolo"
 PROMPT 25 34 ""
 FIELD 401@->DESCR
END

STRINGA 34 2 1
BEGIN
 KEY "unit di misura"
 PROMPT 56 34 ""
END

STRINGA 35 10 1
BEGIN
 KEY "quantit"
 PROMPT 60 34 ""
 FIELD 101@->QTA
END

STRINGA 36 10 1
BEGIN
 KEY "quantit lettere"
 PROMPT 72 34 ""
END

END

SECTION FOOTER ODD 9 0 0

LISTA 37 1 1
BEGIN
 KEY "trasporto a cura del mittente"
 PROMPT 4 59 ""
 ITEM "M|x"
END

LISTA 38 1 1
BEGIN
 KEY "trasporto a cura del destinatario"
 PROMPT 13 59 ""
 ITEM "D|x"
END

LISTA 39 1 1
BEGIN
 KEY "trasporto a cura del vettore"
 PROMPT 23 59 ""
 ITEM "V|x"
END

STRINGA 40 45 1
BEGIN
 KEY "nome vettore"
 PROMPT 3 62 ""
END

STRINGA 41 45 1
BEGIN
 KEY "indirizzo vettore"
 PROMPT 3 64 ""
END

DATA 42 8 1
BEGIN
 KEY "data inizio trasporto"
 PROMPT 51 61 ""
 FIELD 33->DATAPART
 FORMAT "1444-"
END

DATA 43 5 1
BEGIN
 KEY "ora inizio trasporto"
 PROMPT 60 61 ""
 FIELD 33->ORAPART
 FORMAT "1444-"
END

STRINGA 44 27 1
BEGIN
 KEY "aspetto beni"
 PROMPT 37 59 ""
END

STRINGA 45 7 1
BEGIN
 KEY "peso"
 PROMPT 73 59 ""
END

STRINGA 46 5 1
BEGIN
 KEY "colli"
 PROMPT 66 59 ""
END

END

SECTION FOOTER LAST 9 0 0

STRINGA 47 5 1
BEGIN
 KEY "scritta SEGUE"
 PROMPT 72 70 "SEGUE"
END

END

END
